/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * Matching.java
 *
 * Created on Feb 7, 2012, 6:02:58 PM
 */
package gui;

import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import logic.MatchingProblem;

/**
 *
 * @author Nate
 */
public class Matching extends javax.swing.JFrame {
    
    boolean wasImported = false;

    /** Creates new form Matching */
    public Matching() {
        initComponents();
    }
    
    public Matching(MatchingProblem imported, String problemName, String problemFilepath){
        initComponents();
        wasImported = true;
        
        this.ProblemNameField.setText(problemName);
        this.FileDestinationField.setText(problemFilepath);
        
        this.ProblemTextArea.setText(imported.getBody());
        
        for(Iterator<String> it = imported.getQas().iterator(); it.hasNext();){
            String first = it.next();
            String second = it.next();
            
            this.MatchingPairField1.setText(first);
            this.MatchingPairField2.setText(second);
            this.AddMatchingPairButton.doClick(); 
        }
             if(imported.getPCA() == 1){
                this.PartialAnswerYesButton.doClick();
             }else{
                this.PartialAnswerNoButton.doClick();
             }
             
         SolutionTextArea.setText(imported.getSolution());
        
         this.StatusLabel.setText("");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        FileDestinationChooser = new javax.swing.JFileChooser();
        HiddenFirstHalfs = new javax.swing.JComboBox();
        HiddenSecondHalfs = new javax.swing.JComboBox();
        PartialButtonAnswerGroup = new javax.swing.ButtonGroup();
        ProblemNameLabel = new javax.swing.JLabel();
        ProblemNameField = new javax.swing.JTextField();
        FileDestinationLabel = new javax.swing.JLabel();
        FileDestinationField = new javax.swing.JTextField();
        DestinationChooserButton = new javax.swing.JButton();
        ProblemTextLabel = new javax.swing.JLabel();
        MatchingPairsLabel = new javax.swing.JLabel();
        MatchingPairField1 = new javax.swing.JTextField();
        MatchingPairField2 = new javax.swing.JTextField();
        AddMatchingPairButton = new javax.swing.JButton();
        MatchingPairsBox = new javax.swing.JComboBox();
        RemoveMatchingPairButton = new javax.swing.JButton();
        BackToSetupButton = new javax.swing.JButton();
        CreateButton = new javax.swing.JButton();
        StatusLabel = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        PartialAnswerQuesionLabel = new javax.swing.JLabel();
        PartialAnswerYesButton = new javax.swing.JRadioButton();
        PartialAnswerNoButton = new javax.swing.JRadioButton();
        OptionsLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        ProblemTextArea = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        SolutionTextArea = new javax.swing.JTextArea();

        FileDestinationChooser.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Matching");
        setLocationByPlatform(true);

        ProblemNameLabel.setText("Problem Name:");

        ProblemNameField.setText("<Enter the Problem Name>");
        ProblemNameField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                ProblemNameFieldFocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                ProblemNameFieldFocusLost(evt);
            }
        });

        FileDestinationLabel.setText("File Destination:");

        FileDestinationField.setText("<Select the File Destination>");

        DestinationChooserButton.setText("Select Destination");
        DestinationChooserButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                DestinationChooserButtonMouseClicked(evt);
            }
        });

        ProblemTextLabel.setText("Problem Text:");

        MatchingPairsLabel.setText("Matching Pairs:");

        MatchingPairField1.setBackground(new java.awt.Color(204, 204, 255));
        MatchingPairField1.setText("<Enter Half of the Matching Pair>");
        MatchingPairField1.setNextFocusableComponent(MatchingPairField2);
        MatchingPairField1.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                MatchingPairField1FocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                MatchingPairField1FocusLost(evt);
            }
        });

        MatchingPairField2.setBackground(new java.awt.Color(204, 204, 255));
        MatchingPairField2.setText("<Enter Half of the Matching Pair>");
        MatchingPairField2.setNextFocusableComponent(AddMatchingPairButton);
        MatchingPairField2.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                MatchingPairField2FocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                MatchingPairField2FocusLost(evt);
            }
        });

        AddMatchingPairButton.setText("Add Matching Pair");
        AddMatchingPairButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                AddMatchingPairButtonMouseClicked(evt);
            }
        });
        AddMatchingPairButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddMatchingPairButtonActionPerformed(evt);
            }
        });

        RemoveMatchingPairButton.setText("Remove Matching Pair");
        RemoveMatchingPairButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                RemoveMatchingPairButtonMouseClicked(evt);
            }
        });

        BackToSetupButton.setText("Back");
        BackToSetupButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                BackToSetupButtonMouseClicked(evt);
            }
        });
        BackToSetupButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BackToSetupButtonActionPerformed(evt);
            }
        });

        CreateButton.setText("Create");
        CreateButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                CreateButtonMouseClicked(evt);
            }
        });

        StatusLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        StatusLabel.setText("Fill in the fields to create a matching problem.");

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        PartialAnswerQuesionLabel.setText("Show students partial correct answers?");

        PartialButtonAnswerGroup.add(PartialAnswerYesButton);
        PartialAnswerYesButton.setText("Yes");

        PartialButtonAnswerGroup.add(PartialAnswerNoButton);
        PartialAnswerNoButton.setSelected(true);
        PartialAnswerNoButton.setText("No");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(PartialAnswerQuesionLabel)
                .addGap(18, 18, 18)
                .addComponent(PartialAnswerYesButton)
                .addGap(18, 18, 18)
                .addComponent(PartialAnswerNoButton)
                .addContainerGap(144, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(PartialAnswerQuesionLabel)
                    .addComponent(PartialAnswerYesButton)
                    .addComponent(PartialAnswerNoButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        OptionsLabel.setText("Options:");

        ProblemTextArea.setBackground(new java.awt.Color(255, 255, 204));
        ProblemTextArea.setColumns(20);
        ProblemTextArea.setFont(new java.awt.Font("Tahoma", 0, 11));
        ProblemTextArea.setLineWrap(true);
        ProblemTextArea.setRows(5);
        ProblemTextArea.setText("<Enter the Problem Text>");
        ProblemTextArea.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                ProblemTextAreaFocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                ProblemTextAreaFocusLost(evt);
            }
        });
        jScrollPane1.setViewportView(ProblemTextArea);

        jLabel1.setText("Detailed Solution (Optional):");

        SolutionTextArea.setBackground(new java.awt.Color(255, 255, 204));
        SolutionTextArea.setColumns(20);
        SolutionTextArea.setFont(new java.awt.Font("Tahoma", 0, 11));
        SolutionTextArea.setRows(5);
        jScrollPane2.setViewportView(SolutionTextArea);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 465, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 465, Short.MAX_VALUE)
                    .addComponent(ProblemNameField, javax.swing.GroupLayout.DEFAULT_SIZE, 465, Short.MAX_VALUE)
                    .addComponent(ProblemNameLabel)
                    .addComponent(FileDestinationLabel)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(FileDestinationField, javax.swing.GroupLayout.DEFAULT_SIZE, 323, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(DestinationChooserButton, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(MatchingPairField1, javax.swing.GroupLayout.DEFAULT_SIZE, 339, Short.MAX_VALUE)
                            .addComponent(MatchingPairField2, javax.swing.GroupLayout.DEFAULT_SIZE, 339, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(AddMatchingPairButton, javax.swing.GroupLayout.DEFAULT_SIZE, 120, Short.MAX_VALUE))
                    .addComponent(OptionsLabel)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(MatchingPairsBox, javax.swing.GroupLayout.PREFERRED_SIZE, 308, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(RemoveMatchingPairButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(MatchingPairsLabel)
                    .addComponent(ProblemTextLabel)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(BackToSetupButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(StatusLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 337, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(CreateButton))
                    .addComponent(jLabel1))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(ProblemNameLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(ProblemNameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(FileDestinationLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(FileDestinationField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(DestinationChooserButton))
                .addGap(18, 18, 18)
                .addComponent(ProblemTextLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(17, 17, 17)
                .addComponent(MatchingPairsLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(MatchingPairField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(MatchingPairField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(AddMatchingPairButton, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(MatchingPairsBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(RemoveMatchingPairButton))
                .addGap(18, 18, 18)
                .addComponent(OptionsLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 20, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(BackToSetupButton, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(CreateButton)
                    .addComponent(StatusLabel))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private int DuplicateAnswer(){
            
            for(int i = 0; i < MatchingPairsBox.getItemCount(); i++){
                if(MatchingPairField1.getText().equals(HiddenFirstHalfs.getItemAt(i).toString())){
                    return 1;
                }else if(MatchingPairField2.getText().equals(HiddenSecondHalfs.getItemAt(i).toString()))
                    return 2;
            }
        return 0;
    }
    private void ProblemNameFieldFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProblemNameFieldFocusGained
        // TODO add your handling code here:
        if(ProblemNameField.getText().contentEquals("<Enter the Problem Name>")){
            ProblemNameField.setText("");
        }
    }//GEN-LAST:event_ProblemNameFieldFocusGained

    private void ProblemNameFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProblemNameFieldFocusLost
        // TODO add your handling code here:
        if(ProblemNameField.getText().contentEquals("")){
            ProblemNameField.setText("<Enter the Problem Name>");
        }
    }//GEN-LAST:event_ProblemNameFieldFocusLost

    private void DestinationChooserButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_DestinationChooserButtonMouseClicked
        // TODO add your handling code here:
        FileDestinationChooser.showDialog(DestinationChooserButton, "Confirm Destination");
        FileDestinationField.setText(FileDestinationChooser.getSelectedFile().toString());
    }//GEN-LAST:event_DestinationChooserButtonMouseClicked

    private void MatchingPairField1FocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_MatchingPairField1FocusGained
        // TODO add your handling code here:
        if(MatchingPairField1.getText().contentEquals("<Enter Half of the Matching Pair>")){
            MatchingPairField1.setText("");
        }
    }//GEN-LAST:event_MatchingPairField1FocusGained

    private void MatchingPairField1FocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_MatchingPairField1FocusLost
        // TODO add your handling code here:
        if(MatchingPairField1.getText().contentEquals("")){
            MatchingPairField1.setText("<Enter Half of the Matching Pair>");
        }
    }//GEN-LAST:event_MatchingPairField1FocusLost

    private void MatchingPairField2FocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_MatchingPairField2FocusGained
        // TODO add your handling code here:
        if(MatchingPairField2.getText().contentEquals("<Enter Half of the Matching Pair>")){
            MatchingPairField2.setText("");
        }
    }//GEN-LAST:event_MatchingPairField2FocusGained

    private void MatchingPairField2FocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_MatchingPairField2FocusLost
        // TODO add your handling code here:
        if(MatchingPairField2.getText().contentEquals("")){
            MatchingPairField2.setText("<Enter Half of the Matching Pair>");
        }
    }//GEN-LAST:event_MatchingPairField2FocusLost

    private void BackToSetupButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_BackToSetupButtonMouseClicked
        // TODO add your handling code here:
        
    }//GEN-LAST:event_BackToSetupButtonMouseClicked

    private void AddMatchingPairButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_AddMatchingPairButtonMouseClicked
        // TODO add your handling code here:
    }//GEN-LAST:event_AddMatchingPairButtonMouseClicked

    private void RemoveMatchingPairButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_RemoveMatchingPairButtonMouseClicked
        // TODO add your handling code here:
        if(MatchingPairsBox.getItemCount() > 0){
            HiddenFirstHalfs.removeItemAt(MatchingPairsBox.getSelectedIndex());
            HiddenSecondHalfs.removeItemAt(MatchingPairsBox.getSelectedIndex());
            StatusLabel.setText("\"" + MatchingPairsBox.getSelectedItem().toString() + "\" was removed.");
            MatchingPairsBox.removeItemAt(MatchingPairsBox.getSelectedIndex());
        }
    }//GEN-LAST:event_RemoveMatchingPairButtonMouseClicked

    private void CreateButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_CreateButtonMouseClicked
        // TODO add your handling code here:                                         

        if(ProblemNameField.getText().equals("<Enter the Problem Name>") || ProblemNameField.getText().equals("")){
            StatusLabel.setText("Please enter a name for the problem.");
        }else if(FileDestinationField.getText().equals("<Select the File Destination>") || FileDestinationField.getText().equals("")){
            StatusLabel.setText("Please choose a file destination for the problem.");
        }else if(ProblemTextArea.getText().equals("<Enter the Problem Text>") || ProblemTextArea.getText().equals("")){
            StatusLabel.setText("Please enter the text of the problem.");
        }else if(MatchingPairsBox.getItemCount() < 2){
            StatusLabel.setText("Please enter at least two matching pairs for the problem.");
        }else{
                MatchingProblem problem = new MatchingProblem();
		problem.setHeader("Match the pairs of answers below.");
		problem.setBody(ProblemTextArea.getText());
                String filename = FileDestinationField.getText() + "\\" + ProblemNameField.getText() + ".pg";
                
                if(SolutionTextArea.getText() != null){
                     problem.setSolution(SolutionTextArea.getText());
                }
                
                for(int i = 0; i < MatchingPairsBox.getItemCount(); i++){
                    problem.addQa(HiddenFirstHalfs.getItemAt(i).toString(), HiddenSecondHalfs.getItemAt(i).toString());
                }
                
                if(PartialAnswerYesButton.isSelected()){
                    problem.setShowPartialCorrectAnswers(1);
                }else{
                    problem.setShowPartialCorrectAnswers(0);
                }
                
                File blankFile = new File(filename);
                boolean nonduplicate = false;
                
                try {
                     nonduplicate = blankFile.createNewFile();
                }catch (IOException ex) {
                    Logger.getLogger(MultipleChoice.class.getName()).log(Level.SEVERE, null, ex);
                }
                
                if(nonduplicate == false){ //file already exists, ask to overwrite
                    if(JOptionPane.showConfirmDialog(rootPane, "Problem" + ProblemNameField.getText() + ".pg already exists. Overwrite this problem?" , "Overwrite Problem", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
                        //delete file, exportFile() creates new version
                        File oldFile = new File(filename);
                        oldFile.delete();
                    }
                }else{ //file hadn't existed yet, delete blankFile
                        blankFile.delete();
                }
                
		int exported = problem.exportFile(filename);
                
		if (exported == 0 || exported == 2){
                    System.out.println("ZERO");
                    if(nonduplicate == true){
                         StatusLabel.setText("\"" + ProblemNameField.getText() + ".pg\" was successfully created.");
                    }else{
                         StatusLabel.setText("\"" + ProblemNameField.getText() + ".pg\" was successfully overwritten.");
                    }
                }else if(exported == 1){
                    System.out.println("ONE");
                    StatusLabel.setText("\"" + ProblemNameField.getText() + ".pg\" already exists at that location.");
                }
        }
    }//GEN-LAST:event_CreateButtonMouseClicked

    private void BackToSetupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BackToSetupButtonActionPerformed
        // TODO add your handling code here:
        boolean back = false;
        String backMessage = "Are you sure you want to go back? Any unfinished work will not be saved.";
        if(JOptionPane.showConfirmDialog(rootPane, backMessage, "Back to Question Type Selection", JOptionPane.OK_CANCEL_OPTION) == JOptionPane.OK_OPTION){
            if(wasImported){
                new Welcome().setVisible(true);
            }else{
                new ProblemSetup().setVisible(true);
            }
       // this.setVisible(false);
          this.dispose();
        }
    }//GEN-LAST:event_BackToSetupButtonActionPerformed

    private void ProblemTextAreaFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProblemTextAreaFocusGained
        // TODO add your handling code here:
        if(ProblemTextArea.getText().contentEquals("<Enter the Problem Text>")){
            ProblemTextArea.setText("");
        }
    }//GEN-LAST:event_ProblemTextAreaFocusGained

    private void ProblemTextAreaFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProblemTextAreaFocusLost
        // TODO add your handling code here:
        if(ProblemTextArea.getText().contentEquals("")){
            ProblemTextArea.setText("<Enter the Problem Text>");
        }
    }//GEN-LAST:event_ProblemTextAreaFocusLost

    private void AddMatchingPairButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AddMatchingPairButtonActionPerformed
        // TODO add your handling code here:
        if(MatchingPairField1.getText().contentEquals("<Enter Half of the Matching Pair>") || MatchingPairField1.getText().contentEquals("") || MatchingPairField2.getText().contentEquals("<Enter Half of the Matching Pair>") || MatchingPairField2.getText().contentEquals("")){
            StatusLabel.setText("Please fill in both fields to create a matching pair.");
        }else if(DuplicateAnswer() == 1){
            StatusLabel.setText("\"" + MatchingPairField1.getText() + "\" is already the first part of a pair.");
            
        }else if(DuplicateAnswer() == 2){
            StatusLabel.setText("\"" + MatchingPairField2.getText() + "\" is already the second part of a pair.");
            
        }else{
           HiddenFirstHalfs.addItem(MatchingPairField1.getText());
           HiddenSecondHalfs.addItem(MatchingPairField2.getText());
           String h1 = MatchingPairField1.getText();
           String h2 = MatchingPairField2.getText();
           String trim;
           String t1 = MatchingPairField1.getText();
           String t2 = MatchingPairField2.getText();
           if(MatchingPairField1.getText().length() > 20){
             h1 = MatchingPairField1.getText().substring(0,19) + "...";
             t1 = MatchingPairField1.getText().substring(0,9) + "...";
           }
           if(MatchingPairField2.getText().length() > 20){
             h2 = MatchingPairField2.getText().substring(0,19) + "...";
             t2 = MatchingPairField2.getText().substring(0,9) + "...";
           }
           MatchingPairField1.setText("");
           MatchingPairField2.setText("");
           trim = t1 + " :: " + t2;
           MatchingPairsBox.addItem(trim);
           StatusLabel.setText("\"" + trim + "\" was added as a matching pair." );
        }
    }//GEN-LAST:event_AddMatchingPairButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Matching.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Matching.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Matching.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Matching.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new Matching().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton AddMatchingPairButton;
    private javax.swing.JButton BackToSetupButton;
    private javax.swing.JButton CreateButton;
    private javax.swing.JButton DestinationChooserButton;
    private javax.swing.JFileChooser FileDestinationChooser;
    private javax.swing.JTextField FileDestinationField;
    private javax.swing.JLabel FileDestinationLabel;
    private javax.swing.JComboBox HiddenFirstHalfs;
    private javax.swing.JComboBox HiddenSecondHalfs;
    private javax.swing.JTextField MatchingPairField1;
    private javax.swing.JTextField MatchingPairField2;
    private javax.swing.JComboBox MatchingPairsBox;
    private javax.swing.JLabel MatchingPairsLabel;
    private javax.swing.JLabel OptionsLabel;
    private javax.swing.JRadioButton PartialAnswerNoButton;
    private javax.swing.JLabel PartialAnswerQuesionLabel;
    private javax.swing.JRadioButton PartialAnswerYesButton;
    private javax.swing.ButtonGroup PartialButtonAnswerGroup;
    private javax.swing.JTextField ProblemNameField;
    private javax.swing.JLabel ProblemNameLabel;
    private javax.swing.JTextArea ProblemTextArea;
    private javax.swing.JLabel ProblemTextLabel;
    private javax.swing.JButton RemoveMatchingPairButton;
    private javax.swing.JTextArea SolutionTextArea;
    private javax.swing.JLabel StatusLabel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    // End of variables declaration//GEN-END:variables
}
