/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor. 
 */

/*
 * MultipleChoice.java
 *
 * Created on Feb 2, 2012, 7:44:42 AM
 */
package gui;


import java.awt.Color;
import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import logic.MultiProblem;
import logic.Choice;


public class MultipleChoice extends javax.swing.JFrame {

    private LinkedList<Choice> choices = new LinkedList<Choice>();
    
    MultiProblem problem = new MultiProblem();
    boolean wasImported = false;
    
    /** Creates new form MultipleChoice */
    public MultipleChoice() {
        initComponents();
    }
    
    public MultipleChoice(MultiProblem imported, String problemName, String problemFilepath) {
        initComponents();
        ProblemTextArea.setText(imported.getBody());
        wasImported = true;
        
        this.ProblemNameField.setText(problemName);
        this.FileDestinationField.setText(problemFilepath);
        
        for(Iterator<String> it = imported.getAnswers().iterator(); it.hasNext();){
            String answer = it.next();
            ChoiceField.setText(answer);
            this.AddAsCorrect.doClick();
            if(answer.equals(imported.getBottomChoice())){
                this.BottomChoiceButton.doClick();
            }
        }
        
        for(Iterator<String> it = imported.getChoices().iterator(); it.hasNext();){
            String choice = it.next();
            ChoiceField.setText(choice);
            this.AddIncorrectButton.doClick();
            if(choice.equals(imported.getBottomChoice())){
                this.BottomChoiceButton.doClick();
            }
        }
        
        if(imported.getIsCheckBox()){
            this.BoxesYesRadioButton.doClick();
        }else{
            this.BoxesNoRadioButton.doClick();
        }
       
        
        SolutionTextArea.setText(imported.getSolution());
        
        this.StatusLabel.setText("");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        FileDestinationChooser = new javax.swing.JFileChooser();
        PartialButtonGroup = new javax.swing.ButtonGroup();
        BoxesQuestionButtonGroup = new javax.swing.ButtonGroup();
        jFormattedTextField1 = new javax.swing.JFormattedTextField();
        BackToSetupButton = new javax.swing.JButton();
        ProblemNameLabel = new javax.swing.JLabel();
        ProblemNameField = new javax.swing.JTextField();
        ProblemTextLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        ProblemTextArea = new javax.swing.JTextArea();
        ChoicesLabel = new javax.swing.JLabel();
        ChoiceField = new javax.swing.JTextField();
        CreateButton = new javax.swing.JButton();
        AddIncorrectButton = new javax.swing.JButton();
        ChoicesBox = new javax.swing.JComboBox();
        RemoveChoiceButton = new javax.swing.JButton();
        StatusLabel = new javax.swing.JLabel();
        FileDestinationField = new javax.swing.JTextField();
        DestinationChooserButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        AddAsCorrect = new javax.swing.JButton();
        BottomChoiceButton = new javax.swing.JButton();
        BottomLabel = new javax.swing.JLabel();
        BottomAnswerLabel = new javax.swing.JLabel();
        RemoveBottomChoiceButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        BoxesQuestionLabel = new javax.swing.JLabel();
        BoxesNoRadioButton = new javax.swing.JRadioButton();
        BoxesYesRadioButton = new javax.swing.JRadioButton();
        OptionsLabel = new javax.swing.JLabel();
        DetailedSolutionLabel = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        SolutionTextArea = new javax.swing.JTextArea();

        FileDestinationChooser.setFileHidingEnabled(true);
        FileDestinationChooser.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);

        jFormattedTextField1.setText("jFormattedTextField1");

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Multiple Choice");
        setLocationByPlatform(true);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        BackToSetupButton.setText("Back");
        BackToSetupButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                BackToSetupButtonMouseClicked(evt);
            }
        });

        ProblemNameLabel.setText("Problem Name:");

        ProblemNameField.setText("<Enter the Problem Name>");
        ProblemNameField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                ProblemNameFieldFocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                ProblemNameFieldFocusLost(evt);
            }
        });

        ProblemTextLabel.setText("Problem Text:");

        jScrollPane1.setBackground(new java.awt.Color(255, 255, 204));

        ProblemTextArea.setBackground(new java.awt.Color(255, 255, 204));
        ProblemTextArea.setColumns(20);
        ProblemTextArea.setFont(new java.awt.Font("Tahoma", 0, 11));
        ProblemTextArea.setLineWrap(true);
        ProblemTextArea.setRows(5);
        ProblemTextArea.setText("<Enter the Problem Text>");
        ProblemTextArea.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                ProblemTextAreaFocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                ProblemTextAreaFocusLost(evt);
            }
        });
        jScrollPane1.setViewportView(ProblemTextArea);

        ChoicesLabel.setText("Choices:");

        ChoiceField.setText("<Enter a Choice>");
        ChoiceField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                ChoiceFieldFocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                ChoiceFieldFocusLost(evt);
            }
        });

        CreateButton.setText("Create");
        CreateButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                CreateButtonMouseClicked(evt);
            }
        });

        AddIncorrectButton.setBackground(new java.awt.Color(255, 153, 153));
        AddIncorrectButton.setText("Add As Incorrect Choice");
        AddIncorrectButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                AddIncorrectButtonMouseClicked(evt);
            }
        });
        AddIncorrectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddIncorrectButtonActionPerformed(evt);
            }
        });

        ChoicesBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ChoicesBoxActionPerformed(evt);
            }
        });
        ChoicesBox.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                ChoicesBoxFocusLost(evt);
            }
        });

        RemoveChoiceButton.setBackground(new java.awt.Color(153, 153, 255));
        RemoveChoiceButton.setText("Remove Choice");
        RemoveChoiceButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                RemoveChoiceButtonMouseClicked(evt);
            }
        });
        RemoveChoiceButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RemoveChoiceButtonActionPerformed(evt);
            }
        });

        StatusLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        StatusLabel.setText("Fill in the fields to create a multiple choice problem.");

        FileDestinationField.setText("<Select the File Destination>");
        FileDestinationField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FileDestinationFieldActionPerformed(evt);
            }
        });

        DestinationChooserButton.setText("Select Destination");
        DestinationChooserButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                DestinationChooserButtonMouseClicked(evt);
            }
        });

        jLabel1.setText("File Destination:");

        AddAsCorrect.setBackground(new java.awt.Color(102, 255, 102));
        AddAsCorrect.setText("Add As Correct Choice");
        AddAsCorrect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddAsCorrectActionPerformed(evt);
            }
        });

        BottomChoiceButton.setBackground(new java.awt.Color(153, 153, 255));
        BottomChoiceButton.setText("Mark as Bottom Choice");
        BottomChoiceButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BottomChoiceButtonActionPerformed(evt);
            }
        });

        BottomLabel.setText("Current Bottom Choice:");

        BottomAnswerLabel.setText("None Selected");

        RemoveBottomChoiceButton.setBackground(new java.awt.Color(153, 153, 255));
        RemoveBottomChoiceButton.setText("Clear Bottom Choice");
        RemoveBottomChoiceButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RemoveBottomChoiceButtonActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        BoxesQuestionLabel.setText("Allow students to select mutiple answers?");

        BoxesQuestionButtonGroup.add(BoxesNoRadioButton);
        BoxesNoRadioButton.setSelected(true);
        BoxesNoRadioButton.setText("No");

        BoxesQuestionButtonGroup.add(BoxesYesRadioButton);
        BoxesYesRadioButton.setText("Yes");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(BoxesQuestionLabel)
                .addGap(18, 18, 18)
                .addComponent(BoxesYesRadioButton)
                .addGap(18, 18, 18)
                .addComponent(BoxesNoRadioButton)
                .addContainerGap(166, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(BoxesQuestionLabel)
                .addComponent(BoxesYesRadioButton)
                .addComponent(BoxesNoRadioButton))
        );

        OptionsLabel.setText("Options:");

        DetailedSolutionLabel.setText("Detailed Solution (Optional):");

        SolutionTextArea.setBackground(new java.awt.Color(255, 255, 204));
        SolutionTextArea.setColumns(20);
        SolutionTextArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        SolutionTextArea.setRows(5);
        jScrollPane2.setViewportView(SolutionTextArea);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel1)
                    .addComponent(ProblemNameLabel)
                    .addComponent(ProblemTextLabel)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(FileDestinationField, javax.swing.GroupLayout.PREFERRED_SIZE, 347, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(DestinationChooserButton, javax.swing.GroupLayout.DEFAULT_SIZE, 144, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(AddAsCorrect, javax.swing.GroupLayout.DEFAULT_SIZE, 157, Short.MAX_VALUE)
                        .addGap(183, 183, 183)
                        .addComponent(AddIncorrectButton, javax.swing.GroupLayout.DEFAULT_SIZE, 157, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(BottomChoiceButton, javax.swing.GroupLayout.DEFAULT_SIZE, 152, Short.MAX_VALUE)
                            .addComponent(RemoveBottomChoiceButton, javax.swing.GroupLayout.DEFAULT_SIZE, 152, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(BottomLabel)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 121, Short.MAX_VALUE)
                                .addComponent(RemoveChoiceButton))
                            .addComponent(BottomAnswerLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 323, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(BackToSetupButton, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(StatusLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 361, Short.MAX_VALUE)
                        .addGap(10, 10, 10)
                        .addComponent(CreateButton))
                    .addComponent(ProblemNameField, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 497, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 497, Short.MAX_VALUE)
                    .addComponent(ChoicesLabel)
                    .addComponent(ChoiceField, javax.swing.GroupLayout.DEFAULT_SIZE, 497, Short.MAX_VALUE)
                    .addComponent(ChoicesBox, 0, 497, Short.MAX_VALUE)
                    .addComponent(OptionsLabel)
                    .addComponent(DetailedSolutionLabel)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 497, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(ProblemNameLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ProblemNameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(FileDestinationField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(DestinationChooserButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(ProblemTextLabel)
                .addGap(4, 4, 4)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(ChoicesLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ChoiceField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(AddIncorrectButton)
                    .addComponent(AddAsCorrect))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ChoicesBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(11, 11, 11)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(RemoveChoiceButton)
                    .addComponent(BottomLabel)
                    .addComponent(BottomChoiceButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(RemoveBottomChoiceButton)
                    .addComponent(BottomAnswerLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(OptionsLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(DetailedSolutionLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(BackToSetupButton)
                    .addComponent(StatusLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(CreateButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void FixMultipleSelection(){
        if(CountCorrectAnswers(choices) > 1){
            BoxesYesRadioButton.setSelected(true);
            BoxesNoRadioButton.setEnabled(false);
        }else{
            BoxesNoRadioButton.setEnabled(true);
        }
    }
    private int CountCorrectAnswers(LinkedList<Choice> choices){
        int correctAnswers = 0;
        
        for(int i = 0; i <= choices.size()-1; i++){
            if(choices.get(i).getCorrect() == true){
                correctAnswers++;
            }
        }
        return correctAnswers;
    }
    private boolean OneCorrectAnswer(LinkedList<Choice> choices){
        boolean oneCorrectAnswer = false;
        
        for(int i = 0; i <= choices.size()-1; i++){
            if(choices.get(i).getCorrect() == true){
                oneCorrectAnswer = true;
            }
        }
        return oneCorrectAnswer;
    }
    
    private boolean RepeatAnswer(LinkedList<Choice> choices, String newChoice){
        boolean repeatAnswer = false;
        
        for(int i = 0; i <= choices.size()-1; i++){
            if(choices.get(i).getText().equals(newChoice)){
                repeatAnswer = true;
            }
        }
        return repeatAnswer;
    }
    private void BackToSetupButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_BackToSetupButtonMouseClicked
        // TODO add your handling code here:
        boolean back = false;
        String backMessage = "Are you sure you want to go back? Any unfinished work will not be saved.";
        if(JOptionPane.showConfirmDialog(rootPane, backMessage, "Back to Question Type Selection", JOptionPane.OK_CANCEL_OPTION) == JOptionPane.OK_OPTION){
            if(wasImported){
                new Welcome().setVisible(true); 
            }else{
                new ProblemSetup().setVisible(true);
            }
        //this.setVisible(false);
        this.dispose();
        }
    }//GEN-LAST:event_BackToSetupButtonMouseClicked

    private void ProblemNameFieldFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProblemNameFieldFocusGained
        // TODO add your handling code here:
        if(ProblemNameField.getText().contentEquals("<Enter the Problem Name>")){
            ProblemNameField.setText("");
        }
    }//GEN-LAST:event_ProblemNameFieldFocusGained

    private void ProblemNameFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProblemNameFieldFocusLost
        // TODO add your handling code here:
        if(ProblemNameField.getText().contentEquals("")){
            ProblemNameField.setText("<Enter the Problem Name>");
        }
    }//GEN-LAST:event_ProblemNameFieldFocusLost

    private void ProblemTextAreaFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProblemTextAreaFocusGained
        // TODO add your handling code here:
        if(ProblemTextArea.getText().contentEquals("<Enter the Problem Text>")){
            ProblemTextArea.setText("");
        }
    }//GEN-LAST:event_ProblemTextAreaFocusGained

    private void ProblemTextAreaFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProblemTextAreaFocusLost
        // TODO add your handling code here:
        if(ProblemTextArea.getText().contentEquals("")){
            ProblemTextArea.setText("<Enter the Problem Text>");
        }
    }//GEN-LAST:event_ProblemTextAreaFocusLost

    private void ChoiceFieldFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ChoiceFieldFocusGained
        // TODO add your handling code here:
        if(ChoiceField.getText().contentEquals("<Enter a Choice>")){
            ChoiceField.setText("");
        }
    }//GEN-LAST:event_ChoiceFieldFocusGained

    private void ChoiceFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ChoiceFieldFocusLost
        // TODO add your handling code here:
        if(ChoiceField.getText().contentEquals("")){
            ChoiceField.setText("<Enter a Choice>");
        }
    }//GEN-LAST:event_ChoiceFieldFocusLost

    private void AddIncorrectButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_AddIncorrectButtonMouseClicked
        // TODO add your handling code here:
       /* if(IncorrectAnswerField.getText().contentEquals("<Enter an Incorrect Answer>") || IncorrectAnswerField.getText().contentEquals("")){
        }else{
            String incorrectAnswer = IncorrectAnswerField.getText();
            IncorrectAnswerBox.addItem(incorrectAnswer);
            IncorrectAnswerField.setText("");
        }*/
    }//GEN-LAST:event_AddIncorrectButtonMouseClicked

    private void RemoveChoiceButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_RemoveChoiceButtonMouseClicked
        // TODO add your handling code here:
        
    }//GEN-LAST:event_RemoveChoiceButtonMouseClicked

    private void RemoveChoiceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RemoveChoiceButtonActionPerformed
        // TODO add your handling code here:
        if(ChoicesBox.getItemCount() > 0){
            
            Choice removed = choices.get(ChoicesBox.getSelectedIndex());
            choices.remove(ChoicesBox.getSelectedIndex());
            ChoicesBox.removeItemAt(ChoicesBox.getSelectedIndex());
            
            if(removed.getText().equals(BottomAnswerLabel.getText())){
                problem.markBottomChoice(null);
                BottomAnswerLabel.setText("None Selected");
            }
            
           
            if(removed.getCorrect() == false){
                problem.removeChoice(removed.getText());
                StatusLabel.setText("\"" + removed.getText() + "\"" + " was removed as an incorrect choice.");
            }else{
                problem.removeAnswer(removed.getText());
                StatusLabel.setText("\"" + removed.getText() + "\"" + " was removed as an correct choice.");
            }
            
            FixMultipleSelection();
            ChoicesBox.actionPerformed(evt);
        }
    }//GEN-LAST:event_RemoveChoiceButtonActionPerformed

    private void CreateButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_CreateButtonMouseClicked

        if(ProblemNameField.getText().equals("<Enter the Problem Name>") || ProblemNameField.getText().equals("")){
            StatusLabel.setText("Please enter a name for the problem.");
        }else if(FileDestinationField.getText().equals("<Select the File Destination>") || FileDestinationField.getText().equals("")){
            StatusLabel.setText("Please choose a file destination for the problem.");
        }else if(ProblemTextArea.getText().equals("<Enter the Problem Text>") || ProblemTextArea.getText().equals("")){
            StatusLabel.setText("Please enter the text of the problem.");
        }else if(choices.size() < 2){
            StatusLabel.setText("Please enter at least two choices for the problem.");
        }else if(OneCorrectAnswer(choices) == false){
            StatusLabel.setText("Please enter at least one correct choice for the problem.");
        }else{
		problem.setHeader("Select the correct answer(s) from the choices below.");
		problem.setBody(ProblemTextArea.getText());
                
                if(SolutionTextArea.getText() != null){
                    problem.setSolution(SolutionTextArea.getText());
                }
                
                String filename = FileDestinationField.getText() + "\\" + ProblemNameField.getText() + ".pg";
                
               
                problem.setShowPartialCorrectAnswers(0);
           
                
                if(BoxesYesRadioButton.isSelected()){
                    problem.setIsCheckBox(true);
                }else{
                    problem.setIsCheckBox(false);
                }
                
                File blankFile = new File(filename);
                boolean nonduplicate = false;
                
                try {
                     nonduplicate = blankFile.createNewFile();
                }catch (IOException ex) {
                    Logger.getLogger(MultipleChoice.class.getName()).log(Level.SEVERE, null, ex);
                }
                
                if(nonduplicate == false){ //file already exists, ask to overwrite
                    if(JOptionPane.showConfirmDialog(rootPane, "Problem" + ProblemNameField.getText() + ".pg already exists. Overwrite this problem?" , "Overwrite Problem", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
                        //delete file, exportFile() creates new version
                        File oldFile = new File(filename);
                        oldFile.delete();
                    }
                }else{ //file hadn't existed yet, delete blankFile
                        blankFile.delete();
                }
                        
                int exported = problem.exportFile(filename);
                
		if (exported == 0 || exported == 2){
                    System.out.println("ZERO");
                    if(nonduplicate == true){
                         StatusLabel.setText("\"" + ProblemNameField.getText() + ".pg\" was successfully created.");
                    }else{
                         StatusLabel.setText("\"" + ProblemNameField.getText() + ".pg\" was successfully overwritten.");
                    }
                }else if(exported == 1){
                    System.out.println("ONE");
                    StatusLabel.setText("\"" + ProblemNameField.getText() + ".pg\" was not overwritten.");
                }
        }
        
    }//GEN-LAST:event_CreateButtonMouseClicked

    private void DestinationChooserButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_DestinationChooserButtonMouseClicked
        // TODO add your handling code here:
        FileDestinationChooser.showDialog(DestinationChooserButton, "Confirm Destination");
        FileDestinationField.setText(FileDestinationChooser.getSelectedFile().getAbsolutePath());
    }//GEN-LAST:event_DestinationChooserButtonMouseClicked

    private void AddIncorrectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AddIncorrectButtonActionPerformed
        // TODO add your handling code here:
        if(ChoiceField.getText().contentEquals("<Enter a Choice>") || ChoiceField.getText().contentEquals("")){
        }else if(RepeatAnswer(choices, ChoiceField.getText()) == true){
            StatusLabel.setText("\"" + ChoiceField.getText() + "\"" + " is already a choice.");
        }else{
            String incorrectChoice = ChoiceField.getText().toString();
            Choice wrong = new Choice(incorrectChoice, false);
            choices.add(wrong);
            if(incorrectChoice.length() > 60){
                ChoicesBox.addItem(incorrectChoice.substring(0, 56) + "...");
                StatusLabel.setText("\"" + incorrectChoice.substring(0, 20) + "...\"" + " was added as an incorrect choice.");
            }else if(incorrectChoice.length() > 20){
                ChoicesBox.addItem(incorrectChoice);
                StatusLabel.setText("\"" + incorrectChoice.substring(0, 20) + "...\"" + " was added as an incorrect choice.");
            }else{
                ChoicesBox.addItem(incorrectChoice);
                StatusLabel.setText("\"" + incorrectChoice + "\"" + " was added as an incorrect choice.");
            }
            ChoicesBox.setSelectedIndex(ChoicesBox.getItemCount()-1);
            ChoicesBox.setBackground(Color.red);
            problem.addChoice(wrong.getText());
            ChoiceField.setText("");
            FixMultipleSelection();
        }
    }//GEN-LAST:event_AddIncorrectButtonActionPerformed

    private void FileDestinationFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FileDestinationFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_FileDestinationFieldActionPerformed

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        // TODO add your handling code here:
    }//GEN-LAST:event_formWindowOpened

    private void AddAsCorrectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AddAsCorrectActionPerformed
        // TODO add your handling code here:
        if(ChoiceField.getText().contentEquals("<Enter a Choice>") || ChoiceField.getText().contentEquals("")){
        }else if(RepeatAnswer(choices, ChoiceField.getText()) == true){
            StatusLabel.setText("\"" + ChoiceField.getText() + "\"" + " is already a choice.");
        }else{
            String correctChoice = ChoiceField.getText().toString();
            Choice right = new Choice(correctChoice, true);
            choices.add(right);
            if(correctChoice.length() > 60){
                ChoicesBox.addItem(correctChoice.substring(0, 56) + "...");
                StatusLabel.setText("\"" + correctChoice.substring(0, 20) + "...\"" + " was added as a correct choice.");
            }else if(correctChoice.length() > 20){
                ChoicesBox.addItem(correctChoice);
                StatusLabel.setText("\"" + correctChoice.substring(0, 20) + "...\"" + " was added as a correct choice.");
            }else{
                ChoicesBox.addItem(correctChoice);
                StatusLabel.setText("\"" + correctChoice + "\"" + " was added as a correct choice.");
            }
            ChoicesBox.setSelectedIndex(ChoicesBox.getItemCount()-1);
            ChoicesBox.setBackground(Color.green);
            problem.addAnswer(right.getText());
            ChoiceField.setText("");
            FixMultipleSelection();
        }
    }//GEN-LAST:event_AddAsCorrectActionPerformed

    private void ChoicesBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ChoicesBoxActionPerformed
        // TODO add your handling code here:
        
        if(ChoicesBox.getSelectedIndex() == -1 && choices.size() > 0){
            ChoicesBox.setSelectedIndex(0);
        }
      
        if(ChoicesBox.getSelectedIndex() < choices.size() && ChoicesBox.getSelectedIndex() > -1){
            if(choices.get(ChoicesBox.getSelectedIndex()).getCorrect() == true){
                System.out.println("GREEN");
                ChoicesBox.setBackground(Color.green);
            }else if(choices.get(ChoicesBox.getSelectedIndex()).getCorrect() == false){
                System.out.println("RED");
                ChoicesBox.setBackground(Color.red);
            }else{
                System.out.println("GRAY FAIL");
                ChoicesBox.setBackground(Color.gray);
            }
        }
        if(ChoicesBox.getSelectedIndex() == -1){
            System.out.println("GRAY -1");
            ChoicesBox.setBackground(Color.gray);
        }
        
            
    }//GEN-LAST:event_ChoicesBoxActionPerformed

    private void ChoicesBoxFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ChoicesBoxFocusLost
        // TODO add your handling code here:
       
    }//GEN-LAST:event_ChoicesBoxFocusLost

    private void BottomChoiceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BottomChoiceButtonActionPerformed
        // TODO add your handling code here:
        Choice bottomChoice = choices.get(ChoicesBox.getSelectedIndex());
        problem.markBottomChoice(bottomChoice.getText());
        BottomAnswerLabel.setText(bottomChoice.getText());
    }//GEN-LAST:event_BottomChoiceButtonActionPerformed

    private void RemoveBottomChoiceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RemoveBottomChoiceButtonActionPerformed
        // TODO add your handling code here:
        if(BottomAnswerLabel.getText().equals("None Selected")){ 
        }else{
            problem.markBottomChoice(null);
            BottomAnswerLabel.setText("None Selected");
        }
    }//GEN-LAST:event_RemoveBottomChoiceButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MultipleChoice.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MultipleChoice.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MultipleChoice.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MultipleChoice.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new MultipleChoice().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton AddAsCorrect;
    private javax.swing.JButton AddIncorrectButton;
    private javax.swing.JButton BackToSetupButton;
    private javax.swing.JLabel BottomAnswerLabel;
    private javax.swing.JButton BottomChoiceButton;
    private javax.swing.JLabel BottomLabel;
    private javax.swing.JRadioButton BoxesNoRadioButton;
    private javax.swing.ButtonGroup BoxesQuestionButtonGroup;
    private javax.swing.JLabel BoxesQuestionLabel;
    private javax.swing.JRadioButton BoxesYesRadioButton;
    private javax.swing.JTextField ChoiceField;
    private javax.swing.JComboBox ChoicesBox;
    private javax.swing.JLabel ChoicesLabel;
    private javax.swing.JButton CreateButton;
    private javax.swing.JButton DestinationChooserButton;
    private javax.swing.JLabel DetailedSolutionLabel;
    private javax.swing.JFileChooser FileDestinationChooser;
    private javax.swing.JTextField FileDestinationField;
    private javax.swing.JLabel OptionsLabel;
    private javax.swing.ButtonGroup PartialButtonGroup;
    private javax.swing.JTextField ProblemNameField;
    private javax.swing.JLabel ProblemNameLabel;
    private javax.swing.JTextArea ProblemTextArea;
    private javax.swing.JLabel ProblemTextLabel;
    private javax.swing.JButton RemoveBottomChoiceButton;
    private javax.swing.JButton RemoveChoiceButton;
    private javax.swing.JTextArea SolutionTextArea;
    private javax.swing.JLabel StatusLabel;
    private javax.swing.JFormattedTextField jFormattedTextField1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    // End of variables declaration//GEN-END:variables
}
