/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * OpenResponse.java
 *
 * Created on Feb 2, 2012, 7:45:45 AM
 */
package gui;

import java.awt.List;
import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;
import logic.FillProblem;
import javax.swing.JOptionPane;
import logic.AnswerStruct;


public class OpenResponse extends javax.swing.JFrame {
    
    FillProblem problem = new FillProblem();
    List answers = new List();
    boolean wasImported = false;

    /** Creates new form OpenResponse */
    public OpenResponse() {
        initComponents();
    }
    
    public OpenResponse(FillProblem imported, String problemName, String problemFilepath) {
        initComponents();
        
        wasImported = true;
        ProblemTextArea.setText(imported.getBody());
        
        this.ProblemNameField.setText(problemName);
        this.FileDestinationField.setText(problemFilepath);
        
        for(Iterator<AnswerStruct> it = imported.getAnswers().iterator(); it.hasNext();){
            AnswerStruct answer = it.next();
            
            System.out.println(answer.getAnswer() + "  "  + answer.getType() + "\n");
            
            if(answer.getType().equals("Expression")){
                problem.addAnswer(answer.getAnswer(), "Expression"); //adds answer to logic list
                answers.add(answer.getAnswer()); //adds answer to GUI list
                AnswerList.setListData(answers.getItems()); //updates shown answers
                CheckBlankCount();
                
            }else if(answer.getType().equals("Numerical")){
                problem.addAnswer(answer.getAnswer(), answer.getTolerance()); //adds answer to logic list
                if(answer.getTolerance() > 0 || answer.getTolerance() < 0){
                     answers.add(answer.getAnswer() + " +/- " + answer.getTolerance()); //adds answer to GUI list
                }else{
                     answers.add(answer.getAnswer()); //adds answer to GUI list
                }
                 AnswerList.setListData(answers.getItems()); //updates shown answers
            
                 if(answer.getAnswer().length() > 20){
                     StatusLabel.setText("\"" + answer.getAnswer().substring(0,20) + "...\"" + " was added as an answer.");
                 }else{
                     StatusLabel.setText("\"" + answer.getAnswer() + "\"" + " was added as an answer.");
                 }
                 
                AnswerTextField.setText(""); //clears answer field
                CheckBlankCount();
                
                
                
              }else if(answer.getType().equals("String")){
                  if(answer.getTolerance() == 0){
                      problem.addAnswer(answer.getAnswer(), false); //adds answer to logic list
                      answers.add(answer.getAnswer()); //adds answer to GUI list
                  }else{
                      problem.addAnswer(answer.getAnswer(), true); //adds answer to logic list
                      answers.add(answer.getAnswer() + " (Case-sensitive)"); //adds answer to GUI list
                  }
                  
                  AnswerList.setListData(answers.getItems()); //updates shown answers
            
                 if(answer.getAnswer().length() > 20){
                     StatusLabel.setText("\"" + answer.getAnswer().substring(0,20) + "...\"" + " was added as an answer.");
                 }else{
                     StatusLabel.setText("\"" + answer.getAnswer() + "\"" + " was added as an answer.");
                 }
          
                    AnswerTextField.setText(""); //clears answer field
                    CheckBlankCount();
              } 
        }
        
        if(imported.getPCA() == 1){
            this.PartialAnswerYesButton.doClick();
        }else{
            this.PartialAnswerNoButton.doClick();
        }
        
        SolutionTextArea.setText(imported.getSolution());
        
        this.StatusLabel.setText("");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        FileDestinationChooser = new javax.swing.JFileChooser();
        buttonGroup1 = new javax.swing.ButtonGroup();
        BackToSetupButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        ProblemTextArea = new javax.swing.JTextArea();
        ProblemNameField = new javax.swing.JTextField();
        ProblemNameButton = new javax.swing.JLabel();
        ProblemTextLabel = new javax.swing.JLabel();
        CreateButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        FileDestinationField = new javax.swing.JTextField();
        DestinationChooserButton = new javax.swing.JButton();
        StatusLabel = new javax.swing.JLabel();
        AnswersLabel = new javax.swing.JLabel();
        AnswerTextField = new javax.swing.JTextField();
        AddWordedAnswerButton = new javax.swing.JButton();
        AddasExpressionButton = new javax.swing.JButton();
        AddAsValueButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        AnswerList = new javax.swing.JList();
        RemoveAnswerButton = new javax.swing.JButton();
        MoveAnswerUpButton = new javax.swing.JButton();
        MoveAnswerDownButton = new javax.swing.JButton();
        OptionsLabel = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        PartialAnswerLabel = new javax.swing.JLabel();
        PartialAnswerYesButton = new javax.swing.JRadioButton();
        PartialAnswerNoButton = new javax.swing.JRadioButton();
        BlanksWarningLabel = new javax.swing.JLabel();
        SolutionLabel = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        SolutionTextArea = new javax.swing.JTextArea();

        FileDestinationChooser.setFileHidingEnabled(true);
        FileDestinationChooser.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Open Response");
        setLocationByPlatform(true);

        BackToSetupButton.setText("Back");
        BackToSetupButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                BackToSetupButtonMouseClicked(evt);
            }
        });

        jScrollPane1.setBackground(new java.awt.Color(255, 255, 102));

        ProblemTextArea.setBackground(new java.awt.Color(255, 255, 204));
        ProblemTextArea.setColumns(20);
        ProblemTextArea.setFont(new java.awt.Font("Tahoma", 0, 11));
        ProblemTextArea.setLineWrap(true);
        ProblemTextArea.setRows(5);
        ProblemTextArea.setText("<Enter the Problem Text>");
        ProblemTextArea.setWrapStyleWord(true);
        ProblemTextArea.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                ProblemTextAreaFocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                ProblemTextAreaFocusLost(evt);
            }
        });
        jScrollPane1.setViewportView(ProblemTextArea);

        ProblemNameField.setText("<Enter the Problem Name>");
        ProblemNameField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                ProblemNameFieldFocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                ProblemNameFieldFocusLost(evt);
            }
        });

        ProblemNameButton.setText("Problem Name:");

        ProblemTextLabel.setText("Problem Text:");

        CreateButton.setText("Create");
        CreateButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                CreateButtonMouseClicked(evt);
            }
        });

        jLabel1.setText("File Destination:");

        FileDestinationField.setText("<Enter the File Destination>");

        DestinationChooserButton.setText("Select Destination");
        DestinationChooserButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                DestinationChooserButtonMouseClicked(evt);
            }
        });

        StatusLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        StatusLabel.setText("Fill in the fields to create an open response problem.");

        AnswersLabel.setText("Answers:");

        AnswerTextField.setText("<Enter an Answer>");
        AnswerTextField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                AnswerTextFieldFocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                AnswerTextFieldFocusLost(evt);
            }
        });

        AddWordedAnswerButton.setBackground(new java.awt.Color(153, 153, 255));
        AddWordedAnswerButton.setText("Add as Worded Answer");
        AddWordedAnswerButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddWordedAnswerButtonActionPerformed(evt);
            }
        });

        AddasExpressionButton.setBackground(new java.awt.Color(153, 153, 255));
        AddasExpressionButton.setText("Add as Mathematical Expression");
        AddasExpressionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddasExpressionButtonActionPerformed(evt);
            }
        });

        AddAsValueButton.setBackground(new java.awt.Color(153, 153, 255));
        AddAsValueButton.setText("Add as Numerical Value");
        AddAsValueButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddAsValueButtonActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        AnswerList.setBackground(new java.awt.Color(153, 255, 153));
        AnswerList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane2.setViewportView(AnswerList);

        RemoveAnswerButton.setText("Remove Answer");
        RemoveAnswerButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RemoveAnswerButtonActionPerformed(evt);
            }
        });

        MoveAnswerUpButton.setText("Move Answer Up");
        MoveAnswerUpButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MoveAnswerUpButtonActionPerformed(evt);
            }
        });

        MoveAnswerDownButton.setText("Move Answer Down");
        MoveAnswerDownButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MoveAnswerDownButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 328, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(MoveAnswerDownButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(MoveAnswerUpButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(RemoveAnswerButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 81, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addComponent(RemoveAnswerButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(MoveAnswerUpButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(MoveAnswerDownButton)))
                .addContainerGap())
        );

        OptionsLabel.setText("Options:");

        jPanel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        PartialAnswerLabel.setText("Show students partial correct answers?");

        buttonGroup1.add(PartialAnswerYesButton);
        PartialAnswerYesButton.setText("Yes");

        buttonGroup1.add(PartialAnswerNoButton);
        PartialAnswerNoButton.setSelected(true);
        PartialAnswerNoButton.setText("No");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(PartialAnswerLabel)
                .addGap(18, 18, 18)
                .addComponent(PartialAnswerYesButton)
                .addGap(18, 18, 18)
                .addComponent(PartialAnswerNoButton)
                .addContainerGap(168, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(PartialAnswerYesButton)
                    .addComponent(PartialAnswerNoButton)
                    .addComponent(PartialAnswerLabel))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        BlanksWarningLabel.setForeground(new java.awt.Color(255, 0, 0));
        BlanksWarningLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

        SolutionLabel.setText("Detailed Solution: (Optional)");

        SolutionTextArea.setBackground(new java.awt.Color(255, 255, 204));
        SolutionTextArea.setColumns(20);
        SolutionTextArea.setFont(new java.awt.Font("Tahoma", 0, 11));
        SolutionTextArea.setLineWrap(true);
        SolutionTextArea.setRows(5);
        jScrollPane3.setViewportView(SolutionTextArea);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 489, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(SolutionLabel))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(OptionsLabel))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(AnswersLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(BlanksWarningLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 434, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(AnswerTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 489, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(ProblemNameButton)
                            .addComponent(ProblemNameField, javax.swing.GroupLayout.DEFAULT_SIZE, 489, Short.MAX_VALUE)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addComponent(FileDestinationField, javax.swing.GroupLayout.DEFAULT_SIZE, 360, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(DestinationChooserButton)
                                .addGap(4, 4, 4))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(BackToSetupButton)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(StatusLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 355, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(CreateButton))
                            .addComponent(jLabel1)
                            .addComponent(ProblemTextLabel)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 489, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(AddWordedAnswerButton)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(AddAsValueButton)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(AddasExpressionButton, javax.swing.GroupLayout.DEFAULT_SIZE, 189, Short.MAX_VALUE)))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(ProblemNameButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ProblemNameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(FileDestinationField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(DestinationChooserButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ProblemTextLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(AnswersLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(BlanksWarningLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(AnswerTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(11, 11, 11)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(AddWordedAnswerButton)
                    .addComponent(AddAsValueButton)
                    .addComponent(AddasExpressionButton))
                .addGap(18, 18, 18)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(OptionsLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(SolutionLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 17, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(BackToSetupButton)
                    .addComponent(StatusLabel)
                    .addComponent(CreateButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    /**
     * Counts the number of "BLANK"s in ProblemTextArea
     * @return blanks The number of blanks in ProblemTextArea
     */
    private int CountBlanks(){
        String text = ProblemTextArea.getText().toString();
        int blanks = 0;
        for(int i = 0; i <= text.length() - 5; i++){
            if(text.substring(i, i+5).equals("BLANK")){
                blanks++;
            }
        }
        return blanks;
    }
    
    /**
     * Check the number of "BLANK"s against the number of given answers
     *
     * @return 0 if "BLANK"s = answers
     * @return -1 otherwise
     */
    private int CheckBlankCount(){
        int numBlanks;
        int numAnswers;
        
        numBlanks = CountBlanks();
        numAnswers = answers.getItemCount();
        
        if(numBlanks > numAnswers){
            BlanksWarningLabel.setText("Warning: Only " + numAnswers + " out of " + numBlanks + " questions have been given answers.");
            return -1;
        }else if(numBlanks < numAnswers){
            if(numAnswers == 1){
                BlanksWarningLabel.setText("");
                return 0;
            }else{
                BlanksWarningLabel.setText("Warning: Too many answers have been given.");
                return -1;
            }
        }
        BlanksWarningLabel.setText("");
        return 0;
    }
    
    /**
     * If the user has not typed anything into the text area, delete the default 
     * text so they can begin typing immediately
     * 
     * @param evt 
     */
    private void ProblemTextAreaFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProblemTextAreaFocusGained
        // TODO add your handling code here:
        if(ProblemTextArea.getText().contentEquals("<Enter the Problem Text>")){
            ProblemTextArea.setText("");
        }
        CheckBlankCount();
    }//GEN-LAST:event_ProblemTextAreaFocusGained

    /**
     * If the text area is empty, return the default text
     * @param evt 
     */
    private void ProblemTextAreaFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProblemTextAreaFocusLost
        // TODO add your handling code here:
        if(ProblemTextArea.getText().contentEquals("")){
            ProblemTextArea.setText("<Enter the Problem Text>");
        }
        CheckBlankCount();
    }//GEN-LAST:event_ProblemTextAreaFocusLost

    /**
     * If the user has not typed anything into the text field, delete the default 
     * text so they can begin typing immediately
     * 
     * @param evt 
     */
    private void ProblemNameFieldFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProblemNameFieldFocusGained
        // TODO add your handling code here:
        if(ProblemNameField.getText().contentEquals("<Enter the Problem Name>")){
            ProblemNameField.setText("");
        }
    }//GEN-LAST:event_ProblemNameFieldFocusGained
    
    /**
     * If the text field is empty, return the default text
     * 
     * @param evt 
     */
    private void ProblemNameFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProblemNameFieldFocusLost
        // TODO add your handling code here:
        if(ProblemNameField.getText().contentEquals("")){
            ProblemNameField.setText("<Enter the Problem Name>");
        }
    }//GEN-LAST:event_ProblemNameFieldFocusLost

    /**
     * Prompts the user to confirm their decision to go back to the Problem Type
     * Selection screen, and if yes, returns the user to that screen.
     * 
     * @param evt 
     */
    private void BackToSetupButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_BackToSetupButtonMouseClicked
        // TODO add your handling code here:
        boolean back = false;
        String backMessage = "Are you sure you want to go back? Any unfinished work will not be saved.";
        if(JOptionPane.showConfirmDialog(rootPane, backMessage, "Back to Question Type Selection", JOptionPane.OK_CANCEL_OPTION) == JOptionPane.OK_OPTION){
            if(wasImported){
                new Welcome().setVisible(true);
            }else{
                new ProblemSetup().setVisible(true);
            }
        //this.setVisible(false);
        this.dispose();
        }
        
    }//GEN-LAST:event_BackToSetupButtonMouseClicked
    /**
     * Attempts to create the .pg file and save it to the user-specified location
     * 
     * @param evt 
     */
    private void CreateButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_CreateButtonMouseClicked
        // TODO add your handling code here:
        if(ProblemNameField.getText().equals("<Enter the Problem Name>") || ProblemNameField.getText().equals("")){
            StatusLabel.setText("Please enter a name for the problem.");
        }else if(FileDestinationField.getText().equals("<Enter the File Destination>") || FileDestinationField.getText().equals("")){
            StatusLabel.setText("Please choose a file destination for the problem.");
        }else if(ProblemTextArea.getText().equals("<Enter the Problem Text>") || ProblemTextArea.getText().equals("")){
            StatusLabel.setText("Please enter the text of the problem.");
        }else if(CheckBlankCount() == -1){
            StatusLabel.setText("The number of questions does not match the number of answers given.");
        }else if(CountBlanks() == 0 && answers.getItemCount() > 1){
            StatusLabel.setText("Please enter at least one question for the problem.");
        }else{
            FillProblem newProblem = new FillProblem();
            //BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
            newProblem.setHeader("Type the correct answer into the box.");
            newProblem.setBody(ProblemTextArea.getText());
            newProblem.setAnswer(problem.getAnswers());
            if(SolutionTextArea.getText() != null){
                newProblem.setSolution(SolutionTextArea.getText());
            }
          //  fp.setAnswer(AnswerTextField.getText());
            String filename = FileDestinationField.getText() + "\\" + ProblemNameField.getText() + ".pg";
            
             if(PartialAnswerYesButton.isSelected()){
                    newProblem.setShowPartialCorrectAnswers(1);
                }else{
                    newProblem.setShowPartialCorrectAnswers(0);
                }
          
            if(CountBlanks() == 0 && answers.getItemCount() == 1){
                newProblem.setBody(ProblemTextArea.getText() + " BLANK");
            }
            
            
            File blankFile = new File(filename);
                boolean nonduplicate = false;
                
                try {
                     nonduplicate = blankFile.createNewFile();
                }catch (IOException ex) {
                    Logger.getLogger(MultipleChoice.class.getName()).log(Level.SEVERE, null, ex);
                }
                
                if(nonduplicate == false){ //file already exists, ask to overwrite
                    if(JOptionPane.showConfirmDialog(rootPane, "Problem" + ProblemNameField.getText() + ".pg already exists. Overwrite this problem?" , "Overwrite Problem", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
                        //delete file, exportFile() creates new version
                        File oldFile = new File(filename);
                        oldFile.delete();
                    }
                }else{ //file hadn't existed yet, delete blankFile
                        blankFile.delete();
                }
                
            int exported = newProblem.exportFile(filename);
                
		if (exported == 0 || exported == 2){
                    System.out.println("ZERO");
                    if(nonduplicate == true){
                         StatusLabel.setText("\"" + ProblemNameField.getText() + ".pg\" was successfully created.");
                    }else{
                         StatusLabel.setText("\"" + ProblemNameField.getText() + ".pg\" was successfully overwritten.");
                    }
                }else if(exported == 1){
                    System.out.println("ONE");
                    StatusLabel.setText("\"" + ProblemNameField.getText() + ".pg\" already exists at that location.");
                }
        }
        
        for(int i = 0; i < problem.getAnswers().size(); i++){
            System.out.println(problem.getAnswers().get(i).getAnswer());
        }
    }//GEN-LAST:event_CreateButtonMouseClicked

    /**
     * Opens a FileChooser dialog box for the user to select a save destination
     * @param evt 
     */
    private void DestinationChooserButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_DestinationChooserButtonMouseClicked
        FileDestinationChooser.showDialog(DestinationChooserButton, "Confirm Destination");         
        FileDestinationField.setText(FileDestinationChooser.getSelectedFile().getAbsolutePath());
        // TODO add your handling code here:         FileDestinationChooser.showDialog(DestinationChooserButton, "Confirm Destination");         FileDestinationField.setText(FileDestinationChooser.getSelectedFile().toString());     }//GEN-LAST:event_DestinationChooserButtonMouseClicked
    }
    
    /**
     * If the user has not typed anything into the text field, delete the default 
     * text so they can begin typing immediately
     * 
     * @param evt 
     */
        private void AnswerTextFieldFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_AnswerTextFieldFocusGained
        // TODO add your handling code here:
        if(AnswerTextField.getText().contentEquals("<Enter an Answer>")){
            AnswerTextField.setText("");
        }
    }//GEN-LAST:event_AnswerTextFieldFocusGained
    
    /**
    * If the text field is empty, return the default text
    * 
    * @param evt 
    */
    private void AnswerTextFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_AnswerTextFieldFocusLost
        // TODO add your handling code here:
        if(AnswerTextField.getText().contentEquals("")){
            AnswerTextField.setText("<Enter an Answer>");
        }
    }//GEN-LAST:event_AnswerTextFieldFocusLost
    /**
     * Asks the user if the entered answer is case-sensitive, and after receiving
     * a choice, adds the answer to the list of problem answers
     * 
     * @param evt 
     */
    private void AddWordedAnswerButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AddWordedAnswerButtonActionPerformed
        // TODO add your handling code here:
        if(AnswerTextField.getText().equals("") || AnswerTextField.getText().equals("<Enter an Answer>")){
        }else{
            if(JOptionPane.showConfirmDialog(rootPane, "Is this answer case-sensitive?", "Case-Sensitive", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
                problem.addAnswer(AnswerTextField.getText(), true); //adds answer to logic list
                answers.add(AnswerTextField.getText() + " (Case-sensitive)"); //adds answer to GUI list
                System.out.print("CASESENSITIVE");
            }else{
                problem.addAnswer(AnswerTextField.getText(), false); //adds answer to logic list
                answers.add(AnswerTextField.getText()); //adds answer to GUI list
                System.out.print("NONCASESENSITIVE");
            }
            
            
            AnswerList.setListData(answers.getItems()); //updates shown answers
            
            if(AnswerTextField.getText().length() > 20){
                StatusLabel.setText("\"" + AnswerTextField.getText().substring(0,20) + "...\"" + " was added as an answer.");
            }else{
                StatusLabel.setText("\"" + AnswerTextField.getText() + "\"" + " was added as an answer.");
            }
          
            AnswerTextField.setText(""); //clears answer field
            CheckBlankCount();
        }
    }//GEN-LAST:event_AddWordedAnswerButtonActionPerformed
    /**
     * Removes the selected answer from the list of problem answers
     * @param evt 
     */
    private void RemoveAnswerButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RemoveAnswerButtonActionPerformed
        // TODO add your handling code here:
       
        int removedIndex = AnswerList.getSelectedIndex(); //gets selected index
      
        if(removedIndex > -1){
        String removedText = AnswerList.getSelectedValue().toString();
        problem.removeAnswer(problem.getAnswers().get(removedIndex)); //remove from logic list
        answers.remove(removedIndex); //removes from GUI list
        AnswerList.setListData(answers.getItems()); //updates shown answers
        if(removedText.length() > 20){
                StatusLabel.setText("\"" + removedText.substring(0,20) + "...\"" + " was removed as an answer.");
            }else{
                StatusLabel.setText("\"" + removedText + "\"" + " was removed as an answer.");
            }
        }
        CheckBlankCount();
    }//GEN-LAST:event_RemoveAnswerButtonActionPerformed

    /**
     * Swaps the selected answer with the answer above it in the problem answer
     * list, if possible
     * 
     * @param evt 
     */
    private void MoveAnswerUpButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MoveAnswerUpButtonActionPerformed
        // TODO add your handling code here:
        int selectedIndex = AnswerList.getSelectedIndex();
        
       
        if(selectedIndex > 0){  //can't move top value up
            AnswerStruct selectedAS = problem.getAnswers().get(selectedIndex);
            String selectedS = answers.getItem(selectedIndex);
            AnswerStruct tempAS = new AnswerStruct(selectedAS.getType(),selectedAS.getAnswer(), selectedAS.getTolerance());
            
            //set item 1 to item 2
            problem.getAnswers().get(selectedIndex).setType(problem.getAnswers().get(selectedIndex-1).getType());
            problem.getAnswers().get(selectedIndex).setAnswer(problem.getAnswers().get(selectedIndex-1).getAnswer());
            problem.getAnswers().get(selectedIndex).setTolerance(problem.getAnswers().get(selectedIndex-1).getTolerance());
            
            //set temp to item 1
            problem.getAnswers().get(selectedIndex - 1).setType(tempAS.getType());
            problem.getAnswers().get(selectedIndex - 1).setAnswer(tempAS.getAnswer());
            problem.getAnswers().get(selectedIndex - 1).setTolerance(tempAS.getTolerance());
            
            //changes order of strings in answers list
            answers.remove(selectedIndex);
            answers.add(selectedS, selectedIndex-1);
            AnswerList.setListData(answers.getItems()); //updates shown answers
            AnswerList.setSelectedIndex(selectedIndex - 1);
        }
    }//GEN-LAST:event_MoveAnswerUpButtonActionPerformed
    
    /**
     * Swaps the selected answer with the answer below it in the problem answer
     * list, if possible
     * 
     * @param evt 
     */
    private void MoveAnswerDownButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MoveAnswerDownButtonActionPerformed
        // TODO add your handling code here:
        int selectedIndex = AnswerList.getSelectedIndex();
        
       
        if(selectedIndex > -1 && selectedIndex < answers.getItemCount()-1){  //can't move top value up
            AnswerStruct selectedAS = problem.getAnswers().get(selectedIndex);
            String selectedS = answers.getItem(selectedIndex);
            AnswerStruct tempAS = new AnswerStruct(selectedAS.getType(),selectedAS.getAnswer(), selectedAS.getTolerance());
            
            //set item 2 to item 1
            problem.getAnswers().get(selectedIndex).setType(problem.getAnswers().get(selectedIndex+1).getType());
            problem.getAnswers().get(selectedIndex).setAnswer(problem.getAnswers().get(selectedIndex+1).getAnswer());
            problem.getAnswers().get(selectedIndex).setTolerance(problem.getAnswers().get(selectedIndex+1).getTolerance());
            
            //set temp to item 2
            problem.getAnswers().get(selectedIndex + 1).setType(tempAS.getType());
            problem.getAnswers().get(selectedIndex + 1).setAnswer(tempAS.getAnswer());
            problem.getAnswers().get(selectedIndex + 1).setTolerance(tempAS.getTolerance());
            
            //changes order of strings in answers list
            answers.remove(selectedIndex);
            answers.add(selectedS, selectedIndex+1);
            AnswerList.setListData(answers.getItems()); //updates shown answers
            AnswerList.setSelectedIndex(selectedIndex + 1);
        }
    }//GEN-LAST:event_MoveAnswerDownButtonActionPerformed

    /**
     * Asks the user for the allowable tolerance for the entered value, then adds
     * the value to the list of problem answers
     * 
     * @param evt 
     */
    private void AddAsValueButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AddAsValueButtonActionPerformed
        // TODO add your handling code here:
        double tolerance = -1;
        
        if(AnswerTextField.getText().equals("") || AnswerTextField.getText().equals("<Enter an Answer>")){
        }else{
            
            while(tolerance < 0){
                    try{
                       tolerance = Double.parseDouble(JOptionPane.showInputDialog("Please input the allowed margin of error for this answer:", 0));
                    }catch(NumberFormatException e){
                       tolerance = -1;
                 }
             }     
            problem.addAnswer(AnswerTextField.getText(), tolerance); //adds answer to logic list
            if(tolerance > 0 || tolerance < 0){
                answers.add(AnswerTextField.getText() + " +/- " + tolerance); //adds answer to GUI list
            }else{
                answers.add(AnswerTextField.getText()); //adds answer to GUI list
            }
            AnswerList.setListData(answers.getItems()); //updates shown answers
            
            if(AnswerTextField.getText().length() > 20){
                StatusLabel.setText("\"" + AnswerTextField.getText().substring(0,20) + "...\"" + " was added as an answer.");
            }else{
                StatusLabel.setText("\"" + AnswerTextField.getText() + "\"" + " was added as an answer.");
            }
          
            AnswerTextField.setText(""); //clears answer field
            
        }
        CheckBlankCount();
           
    }//GEN-LAST:event_AddAsValueButtonActionPerformed
    /**
     * Adds the entered expression to the list of problem answers
     * 
     * @param evt 
     */
    private void AddasExpressionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AddasExpressionButtonActionPerformed
        // TODO add your handling code here:
         if(AnswerTextField.getText().equals("") || AnswerTextField.getText().equals("<Enter an Answer>")){
        }else{
            problem.addAnswer(AnswerTextField.getText(), "Expression"); //adds answer to logic list
            answers.add(AnswerTextField.getText()); //adds answer to GUI list
            AnswerList.setListData(answers.getItems()); //updates shown answers
            
            if(AnswerTextField.getText().length() > 20){
                StatusLabel.setText("\"" + AnswerTextField.getText().substring(0,20) + "...\"" + " was added as an answer.");
            }else{
                StatusLabel.setText("\"" + AnswerTextField.getText() + "\"" + " was added as an answer.");
            }
          
            AnswerTextField.setText(""); //clears answer field
            
        }
         CheckBlankCount();
    }//GEN-LAST:event_AddasExpressionButtonActionPerformed
             
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(OpenResponse.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(OpenResponse.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(OpenResponse.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(OpenResponse.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new OpenResponse().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton AddAsValueButton;
    private javax.swing.JButton AddWordedAnswerButton;
    private javax.swing.JButton AddasExpressionButton;
    private javax.swing.JList AnswerList;
    private javax.swing.JTextField AnswerTextField;
    private javax.swing.JLabel AnswersLabel;
    private javax.swing.JButton BackToSetupButton;
    private javax.swing.JLabel BlanksWarningLabel;
    private javax.swing.JButton CreateButton;
    private javax.swing.JButton DestinationChooserButton;
    private javax.swing.JFileChooser FileDestinationChooser;
    private javax.swing.JTextField FileDestinationField;
    private javax.swing.JButton MoveAnswerDownButton;
    private javax.swing.JButton MoveAnswerUpButton;
    private javax.swing.JLabel OptionsLabel;
    private javax.swing.JLabel PartialAnswerLabel;
    private javax.swing.JRadioButton PartialAnswerNoButton;
    private javax.swing.JRadioButton PartialAnswerYesButton;
    private javax.swing.JLabel ProblemNameButton;
    private javax.swing.JTextField ProblemNameField;
    private javax.swing.JTextArea ProblemTextArea;
    private javax.swing.JLabel ProblemTextLabel;
    private javax.swing.JButton RemoveAnswerButton;
    private javax.swing.JLabel SolutionLabel;
    private javax.swing.JTextArea SolutionTextArea;
    private javax.swing.JLabel StatusLabel;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    // End of variables declaration//GEN-END:variables
}
